BenhVien/BenhVien.UI/Controllers/DichVuController.cs
using BASICAUTHORIZE.AGRICH;
using BenhVien.MODEL;
using BenhVien.UI.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace BenhVien.UI.Controllers
{
    [RouteArea("QuanTri", AreaPrefix = "admin")]
    [Route("{action}")]
    public class DichVuController : Controller
    {
        public BenhVienEntities db = new BenhVienEntities();
        [Route("dich-vu/main-page")]
        public ActionResult MainPage()
        {
            UserInfo nd_dv = (UserInfo)Session["NguoiDung"];
            if (nd_dv == null || (nd_dv.User.LoaiNguoiDung != EnumUserType.ADMIN && nd_dv.User.LoaiNguoiDung != EnumUserType.SUB_ADMIN))
                return RedirectToAction("Index", "Home", new { area = "" });
            return View();
        }
        [Route("dich-vu/list")]
        public ActionResult List(string keyword = "", int? status = EnumStatus.ACTIVE, int sotrang = 1, int tongsodong = 5)
        {
            UserInfo nd_dv = (UserInfo)Session["NguoiDung"];
            if (nd_dv == null || (nd_dv.User.LoaiNguoiDung != EnumUserType.ADMIN && nd_dv.User.LoaiNguoiDung != EnumUserType.SUB_ADMIN))
                return RedirectToAction("Index", "Home", new { area = "" });

            if (keyword != "")
                keyword = keyword.BoDauTiengViet().ToLower();

            var list = (from a in db.DichVus.ToList()
                        where (keyword == "" || (keyword != "" && (a.Ten.BoDauTiengViet().ToLower().Contains(keyword))
                        || (a.MaDichVu.BoDauTiengViet().ToLower().Contains(keyword))
                        )
                        )
                        && (status == null ? true : a.TrangThaiID == status)
                        select a).OrderBy(x => x.Id);

            int tongso = list.Count();

            sotrang = sotrang <= 0 ? 1 : sotrang;
            tongsodong = tongsodong <= 0 ? 10 : tongsodong;
            int tongsotrang = tongso % tongsodong > 0 ? tongso / tongsodong + 1 : tongso / tongsodong;
            tongsotrang = tongsotrang <= 0 ? 1 : tongsotrang;
            sotrang = sotrang > tongsotrang ? tongsotrang - 1 : sotrang - 1;
            ViewBag.sotrang = sotrang + 1;
            ViewBag.tongsotrang = tongsotrang;
            ViewBag.tongso = tongso;
            return PartialView(list == null ? list : list.Skip(sotrang * tongsodong).Take(tongsodong));
        }
        [Route("dich-vu/update")]
        public ActionResult Update(int? id = null)
        {
            UserInfo nd_dv = (UserInfo)Session["NguoiDung"];
            if (nd_dv == null || (nd_dv.User.LoaiNguoiDung != EnumUserType.ADMIN && nd_dv.User.LoaiNguoiDung != EnumUserType.SUB_ADMIN))
                return RedirectToAction("Index", "Home", new { area = "" });
            var dichVu = db.DichVus.FirstOrDefault(x => x.Id == id);

            string cbxLoaiDichVu = "<option value=\"\">Chọn loại dịch vụ...</option>";
            var loaiDichVu = db.LoaiDichVus.Where(x => x.TrangThaiID == EnumStatus.ACTIVE).ToList();
            foreach (var item in loaiDichVu)
            {
                cbxLoaiDichVu += string.Format("<option value=\"{0}\" {2}>{1}</option>", item.Id, item.Ten, dichVu != null && dichVu.LoaiDichVuID == item.Id ?"selected":"");
            }
            ViewBag.cbxLoaiDichVu = cbxLoaiDichVu;


            return PartialView(dichVu);
        }
        [Route("dich-vu/update")]
        [HttpPost, ValidateInput(false)]
        public ActionResult Update(DichVu dichVu, HttpPostedFileBase _Logo = null)
        {
            UserInfo nd_dv = (UserInfo)Session["NguoiDung"];
            if (nd_dv == null || (nd_dv.User.LoaiNguoiDung != EnumUserType.ADMIN && nd_dv.User.LoaiNguoiDung != EnumUserType.SUB_ADMIN))
                return RedirectToAction("Index", "Home", new { area = "" });
            if (dichVu.Id == 0)
            {
                dichVu.MaDichVu = Functions.CreateCode();
                
                db.DichVus.Add(dichVu);
                db.SaveChanges();
                return Json(new { kq = "ok", msg = "Success!" }, JsonRequestBehavior.AllowGet);
            }
            else
            {
                // up date
                var old = db.DichVus.FirstOrDefault(x => x.Id == dichVu.Id);
                if (old == null)
                    return Json(new { kq = "err", msg = "Thông tin không xác định!" }, JsonRequestBehavior.AllowGet);
                old.Ten = dichVu.Ten;
                old.Gia = dichVu.Gia;
                old.ApDungBHYT = dichVu.ApDungBHYT;
                old.LoaiDichVuID = dichVu.LoaiDichVuID;
                old.TrangThaiID = dichVu.TrangThaiID;
                old.TrangThietBi = dichVu.TrangThietBi.Trim();
                db.SaveChanges();
                return Json(new { kq = "ok", msg = "Success!" }, JsonRequestBehavior.AllowGet);
            }
        }


        [Route("dich-vu/delete")]
        public ActionResult Delete(int? id = null)
        {
            UserInfo nd_dv = (UserInfo)Session["NguoiDung"];
            if (nd_dv == null || (nd_dv.User.LoaiNguoiDung != EnumUserType.ADMIN && nd_dv.User.LoaiNguoiDung != EnumUserType.SUB_ADMIN))
                return RedirectToAction("Index", "Home", new { area = "" });

            var dichVu = db.DichVus.FirstOrDefault(x => x.Id == id);
            if (dichVu == null)
                return Json(new { kq = "err", msg = "Không xác định!" }, JsonRequestBehavior.AllowGet);

            db.DichVus.Remove(dichVu);
            db.SaveChanges();
            return Json(new { kq = "ok", msg = "Thành công!" }, JsonRequestBehavior.AllowGet);
        }

        [Route("dich-vu/change-status")]
        public ActionResult Change_Status(int? id = null)
        {
            UserInfo nd_dv = (UserInfo)Session["NguoiDung"];
            if (nd_dv == null || (nd_dv.User.LoaiNguoiDung != EnumUserType.ADMIN && nd_dv.User.LoaiNguoiDung != EnumUserType.SUB_ADMIN))
                return RedirectToAction("Index", "Home", new { area = "" });

            var dichVu = db.DichVus.FirstOrDefault(x => x.Id == id);
            if (dichVu == null)
                return Json(new { kq = "err", msg = "Không xác định!" }, JsonRequestBehavior.AllowGet);

            if (dichVu.TrangThaiID == EnumStatus.ACTIVE)
                dichVu.TrangThaiID = EnumStatus.INACTIVE;
            else
                dichVu.TrangThaiID = EnumStatus.ACTIVE;
            db.SaveChanges();
            return Json(new { kq = "ok", data = dichVu.TrangThaiID, msg = "Success!" }, JsonRequestBehavior.AllowGet);
        }
        [Route("dich-vu/change-bhyt")]
        public ActionResult ChangeBHYT(int? id = null)
        {
            UserInfo nd_dv = (UserInfo)Session["NguoiDung"];
            if (nd_dv == null || (nd_dv.User.LoaiNguoiDung != EnumUserType.ADMIN && nd_dv.User.LoaiNguoiDung != EnumUserType.SUB_ADMIN))
                return RedirectToAction("Index", "Home", new { area = "" });

            var dichVu = db.DichVus.FirstOrDefault(x => x.Id == id);
            if (dichVu == null)
                return Json(new { kq = "err", msg = "Không xác định!" }, JsonRequestBehavior.AllowGet);

            if (dichVu.ApDungBHYT == EnumStatus.ACTIVE)
                dichVu.ApDungBHYT = EnumStatus.INACTIVE;
            else
                dichVu.ApDungBHYT = EnumStatus.ACTIVE;
            db.SaveChanges();
            return Json(new { kq = "ok", data = dichVu.ApDungBHYT, msg = "Success!" }, JsonRequestBehavior.AllowGet);
        }
    }
}

BenhVien/BenhVien.UI/Views/DichVu/List.cshtml
@using BenhVien.UI.Models;
@model IEnumerable<BenhVien.MODEL.DichVu>
@{
    /**/
    UserInfo nd_dv = (UserInfo)Session["NguoiDung"];
    int stt = 0;

}
@if (Model != null && Model.Count() > 0)
{
    foreach (var item in Model)
    {
        <tr>
            <td class="text-center">@(++stt)</td>
            <td class="text-center">
                <span class="">@item.MaDichVu</span>
            </td>
            <td class="text-center">
                <span class="">@item.Ten</span>
            </td>
            <td class="text-center">
                <span class="">@item.Gia.Value.ToString("#,###")</span>
            </td>
            <td class="text-center">
                <span data-id="@item.Id" onclick="CapNhatBHYT($(this))" style="cursor: pointer" title="Áp dụng bảo hiểm y tế">
                    <i class="fa @(item.ApDungBHYT == EnumStatus.ACTIVE? "fa-unlock":"fa-lock")" style="font-size:22px;"></i>
                </span>
            </td>
            <td class="text-center">
                <span data-id="@item.Id" onclick="CapNhatTrangThai($(this))" style="cursor: pointer" title="Cập nhật trạng thái">
                    <i class="fa @(item.TrangThaiID == EnumStatus.ACTIVE? "fa-unlock":"fa-lock")" style="font-size:22px;"></i>
                </span>
            </td>
          
            <td class="text-center clickable-td">
                <div class="dropdown">
                    <button class="btn btn-xs btn-primary dropdown-toggle" type="button" data-toggle="dropdown" style="width:160px;">
                        Thao tác
                        <span class="caret"></span>
                    </button>
                    <ul class="dropdown-menu">
                        <li>
                            <a class="btn btn-xs btn-success" style="cursor:pointer;padding-right:10px;" onclick="javascript: $('#modal-qltaikhoan').load('@Url.Action("Update","DichVu", new { area = "QuanTri", id = item.Id})', function (e) { $('#modal-qltaikhoan').modal('show'); });"><i class="fa fa-pencil-square-o"></i> Sửa</a>

                        </li>
                        <li>
                            <a class="btn btn-xs btn-danger" data-id="@item.Id" onclick="Xoa($(this))"><i class="fa fa-trash"></i> Xóa</a>
                        </li>
                    </ul>
                </div>

            </td>
        </tr>

    }
}
<script>
    $('#idsotrang').val('@ViewBag.sotrang');
    document.getElementById("idtongsotrang").innerHTML = '@ViewBag.tongsotrang';
    document.getElementById("idtongso").innerHTML = '(' + '@ViewBag.tongso' + ')';
    $(".clickable-td").on("click", function (e) {
        //e.stopPropagation();
        $(".dropdown-toggle").dropdown();
    });

</script>

BenhVien/BenhVien.UI/Views/DichVu/MainPage.cshtml
@using BenhVien.UI.Models;
@model BenhVien.MODEL.DichVu
@{
    Layout = "~/Views/Shared/_Layout_Admin.cshtml";
    UserInfo nd_dv = (UserInfo)Session["NguoiDung"];
}
<div class="row">
    <div class="col-md-12 col-sm-12 col-xs-12 clearfix">
        <div class="x_panel">
            <div class="x_title">
                <h2>Danh sách <span id="permission-name">dịch vụ </span> <span id="idtongso">(0)</span></h2>
                <div class="clearfix"></div>
            </div>
            <div class="">
                <div class="col-md-12 col-sm-12 col-xs-12 clearfix">
                    <div class="col-md-6 col-sm-6 col-xs-12">
                        <div>
                            <input class="form-control" placeholder="Tìm kiếm..." name="tuKhoa" />
                        </div>
                    </div>

                    <div class="col-md-2 col-sm-2 col-sm-12">
                        <a class="btn btn-primary" onclick="DanhSach();">Tìm kiếm</a>
                    </div>


                </div>
            </div>
            <div class="x_content table-responsive">
                <input id="nhomquyenid" type="hidden" value="@EnumStatus.ACTIVE" />
                <ul class="nav nav-tabs bar_tabs nhomquyen" role="tablist">
                    <li role="presentation" class="active"><a href="#" id="@EnumStatus.ACTIVE" data-name="@EnumStatus.ToString(EnumStatus.ACTIVE)" role="tab" data-toggle="tab" aria-expanded="false">@EnumStatus.ToString(EnumStatus.ACTIVE)</a></li>
                    <li role="presentation" class="active"><a href="#" id="@EnumStatus.INACTIVE" data-name="@EnumStatus.ToString(EnumStatus.INACTIVE)" role="tab" data-toggle="tab" aria-expanded="false">@EnumStatus.ToString(EnumStatus.INACTIVE)</a></li>

                </ul>
                <table class="table table-bordered">
                    <thead>
                        <tr>
                            <th class="text-center" width="60">STT</th>
                            <th class="text-center" width="200">Mã dịch vụ</th>
                            <th class="text-center" width="200">Tên dịch vụ</th>
                            <th class="text-center" width="200">Giá</th>
                            <th class="text-center" width="200">Áp dụng BHYT</th>
                            <th class="text-center" width="200">Trạng thái</th>

                            <th width="150" class="text-center">
                                @if (nd_dv.User.LoaiNguoiDung == EnumUserType.ADMIN)
                                {
                                    <a class="btn btn-xs btn-primary" onclick="javascript: $('#modal-qltaikhoan').load('@Url.Action("Update","DichVu", new { area = "QuanTri"})', function (e) { $('#modal-qltaikhoan').modal('show'); });"><i class="fa fa-plus"></i> Thêm mới</a>
                                }
                            </th>
                        </tr>
                    </thead>
                    <tbody id="list"></tbody>
                    <tfoot>
                        <tr>
                            <td colspan="19">
                                <span class="pull-left" style="margin-left:5px;">
                                    <img title="Firt page" alt="Firt page" style="cursor:pointer" onclick="ChoosePage(3)" src="~/Files/images/system/PgFirst.gif" />
                                    &nbsp;
                                    <img title="Next page" alt="Next page" style="cursor:pointer" onclick="ChoosePage(1)" src="~/Files/images/system/PgPrev.gif" />
                                    &nbsp;
                                    <label for="" id="">Page </label>
                                    <input id="idsotrang" style="width:35px;height:28px; text-align:right;" title="Page number input" onkeyup="ChoosePage(0)" />&nbsp;/&nbsp;
                                    <strong id="idtongsotrang" title="Tổng số trang">0</strong>&nbsp;
                                    &nbsp;
                                    <img title="Preview page" alt="Preview page" style="cursor:pointer" onclick="ChoosePage(2)" src="~/Files/images/system/PgNext.gif" />
                                    &nbsp;
                                    <img title="End page" alt="End page" style="cursor:pointer" onclick="ChoosePage(4)" src="~/Files/images/system/PgLast.gif" />
                                </span>
                                <span class="pull-right" style="margin-right:5px;">
                                    <label for="" id="">Số dòng trên 1 trang:</label>
                                    <select name="tongsodong" onchange="ChoosePage(5)" class="DDControl" style="height:30px;">
                                        <option value="5">5</option>
                                        <option value="10">10</option>
                                        <option value="15">15</option>
                                        <option value="20" selected>20</option>
                                        <option value="100">100</option>
                                    </select>
                                </span>
                            </td>
                        </tr>
                    </tfoot>
                </table>

            </div>
        </div>
    </div>
</div>
<div class="modal" tabindex="-1" role="dialog" id="modal-chitiet" style="z-index: 9999;"></div>
<div class="modal" tabindex="-1" role="dialog" id="modal-danhsach"></div>
<div class="modal" tabindex="-1" role="dialog" id="modal-giaodich"></div>

<script>
    mnActive = "mn-dichvu";
    $(document).ready(function () {
        $(".ctr-select").selectpicker({
            width: '100%',
            showTick: true,
        });
        DanhSach();
    });

</script>

<script>
    function DanhSach() {
        $("#list").html("<tr><td colspan='19'><img src='/Files/images/system/loading.gif' style='margin: auto auto;display: block;margin-top: 20px;height:80px;' /></td></tr>");
        $("#list").load("@Url.Action("List", "DichVu", new { area = "QuanTri" })?keyword=" + encodeURI($("[name=tuKhoa]").val()) + "&tongsodong=" + $('[name=tongsodong]').val() + "&status=" + $("#nhomquyenid").val());
    }
</script>
<script>

    $(document).on("change", "[name=tuKhoa]", function () {
        DanhSach();
    });
</script>
<script>
    $(document).on("click", ".nhomquyen li a", function () {
        //change tab view
        $(this).parents(".nhomquyen").find(".active").removeClass("active");
        $(this).parent("li").addClass("active");
        //get nhom quyen
        $("#nhomquyenid").val($(this).attr("id"));
        $("#permission-name").text($(this).attr("data-name"));
        //call function get danh sach
        DanhSach();
        return false;
    });
</script>
<script>
    function ChoosePage(loaichon)//loaichon = 0 nhập số trang, 1 trước, 2 sau, 3 đầu tiên, 4 cuối cùng, 5 chọn số dòng hiển thị
    {
        debugger;
        var tongsotrang = Number($('#idtongsotrang').text())
        var sotrang = Number($('#idsotrang').val());
        console.log(sotrang);
        if (isNaN(sotrang)) {
            alertify.error("Số trang nhập không đúng định dạng số");
            return false;
        }
        if (sotrang > tongsotrang) {
            alertify.error("Số trang nhập không được quá tổng số trang");
            return false;
        }
        if (loaichon == 0)//nhập số trang
        {
            if (sotrang <= 0 || sotrang > tongsotrang) {
                alertify.error("Số trang phải lớn hơn hoặc bằng 1, nhỏ hơn hoặc bằng tổng số trang: " + tongsotrang);
                return false;
            }
        }
        else if (loaichon == 1)// trang trước
        {
            sotrang = sotrang - 1;
            if (sotrang <= 0) {
                alertify.error("Số trang phải lớn hơn hoặc bằng 1");
                return false;
            }
        }
        else if (loaichon == 2)//trang sau
        {
            sotrang = sotrang + 1;
            if (sotrang > tongsotrang) {
                alertify.error("Số trang phải nhỏ hơn hoặc bằng tổng số trang: " + tongsotrang);
                return false;
            }
        }
        else if (loaichon == 3)//trang đầu tiên
        {
            sotrang = 1;
            if (sotrang > tongsotrang) {
                alertify.error("Số trang phải nhỏ hơn hoặc bằng tổng số trang: " + tongsotrang);
                return false;
            }
        }
        else if (loaichon == 4)//trang cuối cùng
        {
            sotrang = tongsotrang;
            if (sotrang > tongsotrang) {
                alertify.error("Số trang phải nhỏ hơn hoặc bằng tổng số trang: " + tongsotrang);
                return false;
            }
        }
        $("#list").html("<tr><td class='text-center' colspan='19'><img src='/Files/images/system/loading.gif' alt='Loading' style='margin: auto auto;display: block;margin-top: 80px;height:80px;' /></td></tr>");
        $("#list").load("@Url.Action("List", "DichVu", new { area = "QuanTri" })?sotrang=" + sotrang + "&tongsodong=" + $('[name=tongsodong]').val() + "&keyword=" + encodeURI($("[name = tuKhoa]").val()) + "&status=" + $('#nhomquyenid').val());
    }
</script>
<script>
    function Xoa(obj) {
        alertify.confirm('Xác nhận xóa?', function (e) {
            if (e) {
            $.ajax({
                url: '@Url.Action("Delete", "DichVu", new { area = "QuanTri" })',
                type: 'GET',
                dataType: 'json',
                mimeType: "multipart/form-data",
                contentType: false,
                async: false,
                cache: false,
                data: { id: obj.attr("data-id") },
                success: function (data) {
                    if (data.kq == "ok") {
                        alertify.success(data.msg);
                        DanhSach();
                        }
                        else {
                            alertify.error(data.msg);
                        }
                    }
                });
            }
        });
    }
</script>

<script>
    function CapNhatTrangThai(obj) {
        alertify.confirm('Xác nhận thay đổi trạng thái?', function (e) {
            if (e) {
                $.ajax({
                    url: '@Url.Action("Change_Status", "DichVu", new { area = "QuanTri" })',
                    type: 'GET',
                    dataType: 'json',
                    mimeType: "multipart/form-data",
                    contentType: false,
                    async: false,
                    cache: false,
                    data: { id: obj.attr("data-id") },
                    success: function (data) {
                        if (data.kq == "ok") {
                            alertify.success(data.msg);
                            if (data.data == @EnumStatus.ACTIVE)
                                obj.html('<i class="fa fa-unlock" style="font-size:22px;"></i>');
                            else
                                obj.html('<i class="fa fa-lock" style="font-size:22px;"></i>');
                            DanhSach();
                        }
                        else {
                            alertify.error(data.msg);
                        }
                    }
                });
            }
        });
    }
</script>
<script>
    function CapNhatTrangThaiDuyet(obj) {
        alertify.confirm('Xác nhận thay đổi trạng thái?', function (e) {
            if (e) {
                $.ajax({
                    url: '@Url.Action("Change_Status", "DichVu", new { area = "QuanTri" })',
                    type: 'GET',
                    dataType: 'json',
                    mimeType: "multipart/form-data",
                    contentType: false,
                    async: false,
                    cache: false,
                    data: { id: obj.attr("data-id") },
                    success: function (data) {
                        if (data.kq == "ok") {
                            alertify.success(data.msg);
                            DanhSach();
                        }
                        else {
                            alertify.error(data.msg);
                        }
                    }
                });
            }
        });
    }
    function CapNhatBHYT(obj) {
        alertify.confirm('Xác nhận cho phép sử dụng bảo hiểm y tế?', function (e) {
            if (e) {
                $.ajax({
                    url: '@Url.Action("ChangeBHYT", "DichVu", new { area = "QuanTri" })',
                    type: 'GET',
                    dataType: 'json',
                    mimeType: "multipart/form-data",
                    contentType: false,
                    async: false,
                    cache: false,
                    data: { id: obj.attr("data-id") },
                    success: function (data) {
                        if (data.kq == "ok") {
                            alertify.success(data.msg);
                            if (data.data == @EnumStatus.ACTIVE)
                                obj.html('<i class="fa fa-unlock" style="font-size:22px;"></i>');
                            else
                                obj.html('<i class="fa fa-lock" style="font-size:22px;"></i>');
                            DanhSach();
                        }
                        else {
                            alertify.error(data.msg);
                        }
                    }
                });
            }
        });
    }
</script>